const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Platform_metricsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const platform_metrics = await db.platform_metrics.create(
      {
        id: data.id || undefined,

        region: data.region || null,
        api_latency_ms: data.api_latency_ms || null,
        uptime_pct: data.uptime_pct || null,
        page_load_ms: data.page_load_ms || null,
        timestamp: data.timestamp || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await platform_metrics.setOrganization(
      currentUser.organization.id || null,
      {
        transaction,
      },
    );

    await platform_metrics.setOrganizations(data.organizations || null, {
      transaction,
    });

    return platform_metrics;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const platform_metricsData = data.map((item, index) => ({
      id: item.id || undefined,

      region: item.region || null,
      api_latency_ms: item.api_latency_ms || null,
      uptime_pct: item.uptime_pct || null,
      page_load_ms: item.page_load_ms || null,
      timestamp: item.timestamp || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const platform_metrics = await db.platform_metrics.bulkCreate(
      platform_metricsData,
      { transaction },
    );

    // For each item created, replace relation files

    return platform_metrics;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const platform_metrics = await db.platform_metrics.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.region !== undefined) updatePayload.region = data.region;

    if (data.api_latency_ms !== undefined)
      updatePayload.api_latency_ms = data.api_latency_ms;

    if (data.uptime_pct !== undefined)
      updatePayload.uptime_pct = data.uptime_pct;

    if (data.page_load_ms !== undefined)
      updatePayload.page_load_ms = data.page_load_ms;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    updatePayload.updatedById = currentUser.id;

    await platform_metrics.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await platform_metrics.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await platform_metrics.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return platform_metrics;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const platform_metrics = await db.platform_metrics.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of platform_metrics) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of platform_metrics) {
        await record.destroy({ transaction });
      }
    });

    return platform_metrics;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const platform_metrics = await db.platform_metrics.findByPk(id, options);

    await platform_metrics.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await platform_metrics.destroy({
      transaction,
    });

    return platform_metrics;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const platform_metrics = await db.platform_metrics.findOne(
      { where },
      { transaction },
    );

    if (!platform_metrics) {
      return platform_metrics;
    }

    const output = platform_metrics.get({ plain: true });

    output.organization = await platform_metrics.getOrganization({
      transaction,
    });

    output.organizations = await platform_metrics.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.region) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('platform_metrics', 'region', filter.region),
        };
      }

      if (filter.api_latency_msRange) {
        const [start, end] = filter.api_latency_msRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            api_latency_ms: {
              ...where.api_latency_ms,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            api_latency_ms: {
              ...where.api_latency_ms,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.uptime_pctRange) {
        const [start, end] = filter.uptime_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            uptime_pct: {
              ...where.uptime_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            uptime_pct: {
              ...where.uptime_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.page_load_msRange) {
        const [start, end] = filter.page_load_msRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            page_load_ms: {
              ...where.page_load_ms,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            page_load_ms: {
              ...where.page_load_ms,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.platform_metrics.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('platform_metrics', 'region', query),
        ],
      };
    }

    const records = await db.platform_metrics.findAll({
      attributes: ['id', 'region'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['region', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.region,
    }));
  }
};
